com.holonplatform.datastore.mongo.spring

## Interface MongoDatastoreConfigProperties

- All Superinterfaces:
    com.holonplatform.core.config.ConfigPropertySet, com.holonplatform.core.datastore.DataContextBound
  All Known Implementing Classes:
    MongoDatastoreConfigProperties.MongoDatastoreConfigPropertiesImpl

      public interface MongoDatastoreConfigProperties
      extends com.holonplatform.core.config.ConfigPropertySet, com.holonplatform.core.datastore.DataContextBound

  A `ConfigPropertySet` for MongoDB Datastore configuration, using `DEFAULT_NAME` as property prefix.
  Since:
    5.2.0

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Interface and Description
    --- | ---
    `static class` | `MongoDatastoreConfigProperties.MongoDatastoreConfigPropertiesImpl` Default implementation

    - ### Nested classes/interfaces inherited from interface com.holonplatform.core.config.ConfigPropertySet

      `com.holonplatform.core.config.ConfigPropertySet.Builder<C extends com.holonplatform.core.config.ConfigPropertySet>, com.holonplatform.core.config.ConfigPropertySet.ConfigurationException`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static com.holonplatform.core.config.ConfigProperty<String>` | `DATABASE` The database name to use.
    `static String` | `DEFAULT_MONGO_CLIENT_BEAN_NAME` Default `MongoClient` bean name to lookup during automatic MongoDB Datastore registration.
    `static String` | `DEFAULT_NAME` Configuration property set default name
    `static com.holonplatform.core.config.ConfigProperty<EnumCodecStrategy>` | `ENUM_CODEC_STRATEGY` The default `EnumCodecStrategy` to use when encoding and decoding enum type values.
    `static com.holonplatform.core.config.ConfigProperty<Boolean>` | `PRIMARY` Whether to qualify the Datastore bean as `primary`, i.e. the preferential bean to be injected in a single-valued dependency when multiple candidates are present.
    `static com.holonplatform.core.config.ConfigProperty<MongoReadConcern>` | `READ_CONCERN` The default `ReadConcern` for the read operations isolation level.
    `static com.holonplatform.core.config.ConfigProperty<MongoReadPreference>` | `READ_PREFERENCE` The default `ReadPreference` for query or data read operations.
    `static com.holonplatform.core.config.ConfigProperty<MongoWriteConcern>` | `WRITE_CONCERN` The default `WriteConcern` for write operations acknowledgment.

  - ### Method Summary

    All Methods Static Methods Default Methods
    Modifier and Type | Method and Description
    --- | ---
    `static com.holonplatform.core.config.ConfigPropertySet.Builder<MongoDatastoreConfigProperties>` | `builder()` Builder to create property set instances bound to a property data source, without data context id specification.
    `static com.holonplatform.core.config.ConfigPropertySet.Builder<MongoDatastoreConfigProperties>` | `builder(String dataContextId)` Builder to create property set instances bound to a property data source.

    - ### Methods inherited from interface com.holonplatform.core.config.ConfigPropertySet

      `getConfigPropertyName, getConfigPropertyValue, getConfigPropertyValue, getConfigPropertyValueOrElse, getName, getSubPropertiesUsingPrefix, hasConfigProperty`

    - ### Methods inherited from interface com.holonplatform.core.datastore.DataContextBound

      `getDataContextId`

- - ### Field Detail

    - #### DEFAULT_MONGO_CLIENT_BEAN_NAME

          static final String DEFAULT_MONGO_CLIENT_BEAN_NAME

      Default `MongoClient` bean name to lookup during automatic MongoDB Datastore registration.
      See Also:
        Constant Field Values

    - #### DEFAULT_NAME

          static final String DEFAULT_NAME

      Configuration property set default name
      See Also:
        Constant Field Values

    - #### PRIMARY

          static final com.holonplatform.core.config.ConfigProperty<Boolean> PRIMARY

      Whether to qualify the Datastore bean as `primary`, i.e. the preferential bean to be injected in a single-valued dependency when multiple candidates are present.

      By default, the registered Datastore bean is marked as primary only when the `MongoClient` bean to which is bound is registered as primary candidate bean.

    - #### DATABASE

          static final com.holonplatform.core.config.ConfigProperty<String> DATABASE

      The database name to use.

    - #### READ_PREFERENCE

          static final com.holonplatform.core.config.ConfigProperty<MongoReadPreference> READ_PREFERENCE

      The default `ReadPreference` for query or data read operations.

      Must be one of the `MongoReadPreference` enumeration names.

    - #### READ_CONCERN

          static final com.holonplatform.core.config.ConfigProperty<MongoReadConcern> READ_CONCERN

      The default `ReadConcern` for the read operations isolation level.

      Must be one of the `MongoReadConcern` enumeration names.

    - #### WRITE_CONCERN

          static final com.holonplatform.core.config.ConfigProperty<MongoWriteConcern> WRITE_CONCERN

      The default `WriteConcern` for write operations acknowledgment.

      Must be one of the `MongoWriteConcern` enumeration names.

    - #### ENUM_CODEC_STRATEGY

          static final com.holonplatform.core.config.ConfigProperty<EnumCodecStrategy> ENUM_CODEC_STRATEGY

      The default `EnumCodecStrategy` to use when encoding and decoding enum type values.

      Must be one of the `EnumCodecStrategy` enumeration names.

  - ### Method Detail

    - #### builder

          static com.holonplatform.core.config.ConfigPropertySet.Builder<MongoDatastoreConfigProperties> builder(String dataContextId)

      Builder to create property set instances bound to a property data source.
      Parameters:
        `dataContextId` - Optional data context id to which `Datastore` is bound
      Returns:
        ConfigPropertySet builder

    - #### builder

          static com.holonplatform.core.config.ConfigPropertySet.Builder<MongoDatastoreConfigProperties> builder()

      Builder to create property set instances bound to a property data source, without data context id specification.
      Returns:
        ConfigPropertySet builder

Copyright © 2019 The Holon Platform. All rights reserved.